Name:           pdfbox
Version:        1.8.1
Release:        1%{?dist}
Summary:        Java library for working with PDF documents

Group:          Development/Libraries
License:        ASL 2.0
URL:            http://pdfbox.apache.org/
Source0:        http://www.apache.org/dist/pdfbox/%{version}/%{name}-%{version}-src.zip
#Don't download anything
Patch0:         %{name}-nodownload.patch
#Use sysytem bitream-vera-sans-fonts instead of bundled fonts
Patch1:         %{name}-1.2.0-bitstream.patch

BuildRequires:  jpackage-utils
BuildRequires:  ant
BuildRequires:  maven-local
BuildRequires:  maven-antrun-plugin
BuildRequires:  maven-plugin-bundle
BuildRequires:  maven-compiler-plugin
BuildRequires:  maven-install-plugin
BuildRequires:  maven-jar-plugin
BuildRequires:  maven-javadoc-plugin
BuildRequires:  maven-resources-plugin
BuildRequires:  maven-surefire-plugin
BuildRequires:  maven-deploy-plugin
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-release-plugin
BuildRequires:  maven-site-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  maven-war-plugin
BuildRequires:  apache-commons-logging
BuildRequires:  apache-rat-plugin
BuildRequires:  bitstream-vera-sans-fonts
BuildRequires:  bouncycastle-mail
BuildRequires:  cobertura-maven-plugin
BuildRequires:  fontconfig
BuildRequires:  icu4j
BuildRequires:  javacc-maven-plugin
BuildRequires:  junit4
%if 0%{?fedora} >= 18
BuildRequires:  lucene
%else
BuildRequires:  lucene-demo >= 2.4.1
%endif
BuildRequires:  pcfi

BuildArch:      noarch

Requires:       jpackage-utils
Requires:       java >= 1:1.6.0
Requires:       bitstream-vera-sans-fonts
Requires:       bouncycastle-mail
Requires:       fontbox
Requires:       icu4j
Requires:       apache-commons-logging
Requires:       jempbox

Obsoletes:      %{name}-app <= 1.6.0-4
Provides:       %{name}-app = %{version}-%{release}

%description
Apache PDFBox is an open source Java PDF library for working with PDF
documents. This project allows creation of new PDF documents, manipulation of
existing documents and the ability to extract content from documents. Apache
PDFBox also includes several command line utilities. Apache PDFBox is
published under the Apache License v2.0.


%package examples
Summary:        Examples for %{name}
Group:          Documentation
Requires:       jpackage-utils

%description examples
This package contains examples for %{name}.


%package javadoc
Summary:        Javadocs for %{name}
Group:          Documentation
Requires:       jpackage-utils
Provides:       fontbox-javadoc = %{version}-%{release}
Obsoletes:      fontbox-javadoc < %{version}-%{release}
Provides:       jempbox-javadoc = %{version}-%{release}
Obsoletes:      jempbox-javadoc < %{version}-%{release}

%description javadoc
This package contains the API documentation for %{name}.


%package ant
Summary:        Apache PDFBox for Ant
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}
Requires:       ant

%description ant
%{summary}.


%package -n fontbox
Summary:        Apache FontBox
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}
Requires:       junit

%description -n fontbox
FontBox is a Java library used to obtain low level information from font
files. FontBox is a subproject of Apache PDFBox.


%package -n jempbox
Summary:        Apache JempBox
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}
Requires:       junit

%description -n jempbox
JempBox is an open source Java library that implements Adobe's XMP(TM)
specification. JempBox is a subproject of Apache PDFBox.


%package -n preflight
Summary:        Apache Preflight
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}
Requires:       xmpbox = %{version}-%{release}

%description -n preflight
The Apache Preflight library is an open source Java tool that implements 
a parser compliant with the ISO-19005 (PDF/A) specification. Preflight is a 
subproject of Apache PDFBox.


%package -n xmpbox
Summary:        Apache XmpBox
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}

%description -n xmpbox
The Apache XmpBox library is an open source Java tool that implements Adobe's
XMP(TM) specification.  It can be used to parse, validate and create xmp
contents.  It is mainly used by subproject preflight of Apache PDFBox. 
XmpBox is a subproject of Apache PDFBox.


# Not compatible with lucene 3.6
%if 0%{?fedora} < 18
%package lucene
Summary:        Apache PDFBox for Lucene
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}
%if 0%{?fedora} >= 18
Requires:       lucene
%else
Requires:       lucene-demo >= 2.4.1
%endif

%description lucene
%{summary}.
%endif


%prep
%setup -q
%patch0 -p1 -b .nodownload
%patch1 -p1 -b .bitstream
#Disable lucene, not compatible with lucene 3
%pom_disable_module lucene
#Use jdk16 version of bcprov
sed -i -e s/jdk15/jdk16/g */pom.xml
# Don't build app (it's just a bundle of everything)
sed -i -e /app/d pom.xml
find -name '*.class' -exec rm -f '{}' \;
find -name '*.jar' -exec rm -f '{}' \;
#Fix line endings
sed -i -e 's|\r||' RELEASE-NOTES.txt
#Remove META-INF file that does not exist
sed -i -e '/META-INF/d' pdfbox/pom.xml
#Remove included fonts
rm -r pdfbox/src/main/resources/org/apache/pdfbox/resources/ttf


%build
mvn-rpmbuild -Dadobefiles.jar=%{_javadir}/pcfi.jar install javadoc:aggregate


%install
mkdir -p $RPM_BUILD_ROOT%{_javadir}
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}
mkdir -p $RPM_BUILD_ROOT%{_mavenpomdir}

for jar in */target/*.jar
do
  dir=$(dirname $jar)
  target=$(dirname $dir)
  jarname=$target
  [ -f ${dir}/%{name}-${target}-%{version}.jar ] && jarname=%{name}-${target}

  cp -p ${dir}/${jarname}-%{version}.jar \
    $RPM_BUILD_ROOT%{_javadir}/${jarname}.jar

  cp -p ${target}/pom.xml $RPM_BUILD_ROOT%{_mavenpomdir}/JPP-${jarname}.pom
  %add_maven_depmap JPP-${jarname}.pom ${jarname}.jar
done

# Javadocs
cp -rp target/site/apidocs $RPM_BUILD_ROOT%{_javadocdir}/%{name}

#Parent
cp -p parent/pom.xml $RPM_BUILD_ROOT%{_mavenpomdir}/JPP-pdfbox-parent.pom
%add_maven_depmap JPP-pdfbox-parent.pom

#TODO - install/ship war


%files
%doc LICENSE.txt NOTICE.txt README.txt RELEASE-NOTES.txt
%{_javadir}/%{name}.jar
%{_mavenpomdir}/JPP-%{name}.pom
%{_mavenpomdir}/JPP-%{name}-parent.pom
%{_mavendepmapfragdir}/%{name}

%files examples
%doc LICENSE.txt
%{_javadir}/%{name}-examples.jar
%{_mavenpomdir}/JPP-%{name}-examples.pom

%files javadoc
%doc LICENSE.txt
%{_javadocdir}/%{name}

%files ant
%doc LICENSE.txt
%{_javadir}/%{name}-ant.jar
%{_mavenpomdir}/JPP-%{name}-ant.pom

%files -n fontbox
%doc LICENSE.txt
%{_javadir}/fontbox.jar
%{_mavenpomdir}/JPP-fontbox.pom

%files -n jempbox
%doc LICENSE.txt
%{_javadir}/jempbox.jar
%{_mavenpomdir}/JPP-jempbox.pom

%files -n preflight
%doc LICENSE.txt
%{_javadir}/preflight.jar
%{_mavenpomdir}/JPP-preflight.pom

%files -n xmpbox
%doc LICENSE.txt
%{_javadir}/xmpbox.jar
%{_mavenpomdir}/JPP-xmpbox.pom

# Not compatible with lucene 3.6
%if 0%{?fedora} < 18
%files lucene
%doc LICENSE.txt
%{_javadir}/%{name}-lucene.jar
%{_mavenpomdir}/JPP-%{name}-lucene.pom
%endif


%changelog
* Wed Apr 17 2013 Orion Poplawski <orion@cora.nwra.com> - 1.8.1-1
- Update to 1.8.1

* Thu Mar 28 2013 Orion Poplawski <orion@cora.nwra.com> - 1.8.0-1
- Update to 1.8.0
- Add preflight and xmpbox sub-packages

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.7.0-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Wed Feb 06 2013 Java SIG <java-devel@lists.fedoraproject.org> - 1.7.0-5
- Update for https://fedoraproject.org/wiki/Fedora_19_Maven_Rebuild
- Replace maven BuildRequires with maven-local

* Mon Sep 24 2012 Orion Poplawski <orion@cora.nwra.com> - 1.7.0-4
- Drop lucene sub-package for now, not compatible with lucene 3.6

* Fri Jul 20 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.7.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Tue Jul 3 2012 Orion Poplawski <orion@cora.nwra.com> - 1.7.0-2
- Fix javadocs -> javadoc typo

* Tue Jul 3 2012 Orion Poplawski <orion@cora.nwra.com> - 1.7.0-1
- Update to 1.7.0
- Add examples sub-package
- Add BR on bitstream font and fontconfig

* Wed Apr 18 2012 Orion Poplawski <orion@cora.nwra.com> - 1.6.0-5
- Drop pdfbox-app sub-package, nothing but a bundle (bug #813712)

* Wed Feb 1 2012 Orion Poplawski <orion@cora.nwra.com> - 1.6.0-4
- Add proper provides/obsoletes to javadoc sub-package (bug #785396)

* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.6.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Mon Oct 24 2011 Orion Poplawski <orion@cora.nwra.com> - 1.6.0-2
- BR separately packaged pcfi

* Wed Aug 10 2011 Orion Poplawski <orion@cora.nwra.com> - 1.6.0-1
- Update to 1.6.0
- Add pcfi-2010.08.09.jar to sources
- Drop depmap
- Use apache-commons-logging
- Other cleanup

* Fri Jun 3 2011 Orion Poplawski <orion@cora.nwra.com> - 1.5.0-2
- Use maven 3
- Single javadoc package

* Thu Mar 10 2011 Orion Poplawski <orion@cora.nwra.com> - 1.5.0-1
- Update to 1.5.0

* Tue Dec 27 2010 Orion Poplawski <orion@cora.nwra.com> - 1.4.0-2
- Create sub-packages
- Use depmap file

* Tue Dec 21 2010 Orion Poplawski <orion@cora.nwra.com> - 1.4.0-1
- Update to 1.4.0

* Sat Nov 6 2010 Orion Poplawski <orion@cora.nwra.com> - 1.3.1-1
- Update to 1.3.1

* Fri Aug 13 2010 Orion Poplawski <orion@cora.nwra.com> - 1.3.0-0.1
- Update to 1.3.0-SNAPSHOT

* Thu Jul 13 2010 Orion Poplawski <orion@cora.nwra.com> - 1.2.1-1
- Update to 1.2.1

* Thu Jul 1 2010 Orion Poplawski <orion@cora.nwra.com> - 1.2.0-1
- Update to 1.2.0
- Drop gcj support

* Mon Oct 19 2009 Orion Poplawski <orion@cora.nwra.com> - 0.8.0-2
- Add Requires

* Thu Oct 15 2009 Orion Poplawski <orion@cora.nwra.com> - 0.8.0-1
- Initial Fedora package

